﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DAL;

namespace Puzzle15Console
{
    public static class GameUiLogic
    {
        public static void StartNewGame(
            Puzzle15Engine.Puzzle15Engine puzzle15Engine, AppDbContext db)
        {
            puzzle15Engine.RandomizeBoard();
            DrawGameBoard(puzzle15Engine);
        }

        public static void MakeMove(Puzzle15Engine.Puzzle15Engine puzzle15Engine, AppDbContext db)
        {
            Console.Write("Give the number on the piece (1-15 or 0 to cancel):");
            var s = Console.ReadLine();
            if (!string.IsNullOrWhiteSpace(s))
            {
                s = s.Trim();
                int pieceNumber;
                if (int.TryParse(s, out pieceNumber))
                {
                    var res = puzzle15Engine.MakeMove(pieceNumber);
                    if (!string.IsNullOrWhiteSpace(res))
                    {
                        Console.WriteLine("Error: " + res);
                    }
                }
                else
                {
                    Console.WriteLine("Error in input.");
                }
            }
        }

        public static void DrawGameBoard(Puzzle15Engine.Puzzle15Engine puzzle15Engine, AppDbContext db)
        {
            DrawGameBoard(puzzle15Engine);
        }

        public static void DrawGameBoard(Puzzle15Engine.Puzzle15Engine puzzle15Engine)
        {
            for (int row = 0; row < 4; row++)
            {
                for (int col = 0; col < 4; col++)
                {
                    var piece = puzzle15Engine.GameBoard[row, col] < 10
                        ? " " + puzzle15Engine.GameBoard[row, col]
                        : puzzle15Engine.GameBoard[row, col].ToString();
                    if (piece == "16")
                    {
                        piece = "  ";
                    }
                    Console.Write(piece + " ");
                }
                Console.WriteLine();
            }
        }
    }
}
