﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Puzzle15Engine
{
    public class Puzzle15Engine
    {
        private int[,] _gameBoard  = new int[4,4];
        public int[,] GameBoard {
            get { return _gameBoard; }
            set { _gameBoard = value; }
        }

        public Puzzle15Engine()
        {
            RandomizeBoard();
        }

        public void RandomizeBoard()
        {
            var bagOfPieces = new List<int>();
            for (int i = 1; i <=16; i++)
            {
                bagOfPieces.Add(i);    
            }

            var random = new Random();
            for (int  row = 0; row < 4; row++)
            {
                for (int col = 0; col < 4; col++)
                {
                    var piecePositionInBag = random.Next(0, bagOfPieces.Count);
                    var piece = bagOfPieces[piecePositionInBag];
                    bagOfPieces.RemoveAt(piecePositionInBag);
                    _gameBoard[row, col] = piece;
                }
            }
        }

        public string MakeMove(int numberOnThePiece)
        {
            if (numberOnThePiece < 1 || numberOnThePiece > 15)
            {
                return "There is no such piece on the board!";
            }

            // TODO: find the piece cordinates
            int row = 0;
            int col = 0;

            return MakeMove(row,col);
        }

        public string MakeMove(int row, int col)
        {
            if (row < 0 || col < 0)
            {
                return "Row or column cant be negative";
            }

            if (row > _gameBoard.GetLength(0) - 1)
            {
                return "Max value for row is: " + (_gameBoard.GetLength(0) - 1);
            }

            if (col > _gameBoard.GetLength(1) - 1)
            {
                return "Max value for column is: " + (_gameBoard.GetLength(1) - 1);
            }

            return "";
        }
    }
}
