﻿using Puzzle15Engine;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Puzzle15Wpf
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private readonly Puzzle15Engine.Puzzle15Engine _puzzle15Engine = new Puzzle15Engine.Puzzle15Engine();
        public MainWindow()
        {
            InitializeComponent();
            UpdateGameBoardUi();
        }

        private void ButtonNewGame_OnClick(object sender, RoutedEventArgs e)
        {
            _puzzle15Engine.RandomizeBoard();
            UpdateGameBoardUi();
        }

        private void UpdateGameBoardUi()
        {
            Button00.Content = _puzzle15Engine.GameBoard[0, 0].ToString();
            Button01.Content = _puzzle15Engine.GameBoard[0, 1].ToString();
            Button02.Content = _puzzle15Engine.GameBoard[0, 2].ToString();
            Button03.Content = _puzzle15Engine.GameBoard[0, 3].ToString();

            Button10.Content = _puzzle15Engine.GameBoard[1, 0].ToString();
            Button11.Content = _puzzle15Engine.GameBoard[1, 1].ToString();
            Button12.Content = _puzzle15Engine.GameBoard[1, 2].ToString();
            Button13.Content = _puzzle15Engine.GameBoard[1, 3].ToString();

            Button20.Content = _puzzle15Engine.GameBoard[2, 0].ToString();
            Button21.Content = _puzzle15Engine.GameBoard[2, 1].ToString();
            Button22.Content = _puzzle15Engine.GameBoard[2, 2].ToString();
            Button23.Content = _puzzle15Engine.GameBoard[2, 3].ToString();

            Button30.Content = _puzzle15Engine.GameBoard[3, 0].ToString();
            Button31.Content = _puzzle15Engine.GameBoard[3, 1].ToString();
            Button32.Content = _puzzle15Engine.GameBoard[3, 2].ToString();
            Button33.Content = _puzzle15Engine.GameBoard[3, 3].ToString();
        }

    }
}
